﻿#include "MQPlugin.h"
#include "MQBasePlugin.h"

class ViewPoint : public MQStationPlugin
{
public:
	friend ViewPointWindow;

	ViewPoint();
	virtual ~ViewPoint();

	// プラグインIDを返す。
	virtual void GetPlugInID(DWORD *Product, DWORD *ID);
	// プラグイン名を返す。
	virtual const char *GetPlugInName(void);
	// ポップアップメニューに表示される文字列を返す。
	virtual const char *EnumString(void);

	// アプリケーションの初期化
	virtual BOOL Initialize();
	// アプリケーションの終了
	virtual void Exit();

	// 表示・非表示切り替え要求
	virtual BOOL Activate(MQDocument doc, BOOL flag);
	// 表示・非表示状態の返答
	virtual BOOL IsActivated(MQDocument doc);

	virtual void OnDraw(MQDocument doc, MQScene scene, int width, int height);
	virtual void OnObjectSelected(MQDocument doc);
	virtual void OnObjectModified(MQDocument doc);
	virtual void OnUpdateObjectList(MQDocument doc);
	virtual BOOL OnUndo(MQDocument doc, int undo_state);
	virtual BOOL OnRedo(MQDocument doc, int redo_state);
	virtual void OnNewDocument(MQDocument doc, const char *filename, NEW_DOCUMENT_PARAM& param);

	typedef bool (ViewPoint::*ExecuteCallbackProc)(MQDocument doc);

	void Execute(ExecuteCallbackProc proc);

protected:
	struct CallbackInfo {
		ExecuteCallbackProc proc;
	};

	// コールバックに対する実装部
	virtual bool ExecuteCallback(MQDocument doc, void *option);

private:
	ViewPointWindow *m_Window;

	BOOL viewPoint(MQDocument doc);
	BOOL clear();

	bool m_bActivate;
	bool m_bUpdate; // リアルタイム更新
};

