#include <windows.h>

#include <string>
#include <sstream>

#include "ViewPointWindow.h"
#include "ViewPoint.h"

ViewPointWindow::ViewPointWindow(ViewPoint *plugin, MQWindowBase& parent) : MQWindow(parent), m_pPlugin(plugin)
{
	SetTitle(L"ViewPoint");

	this->SetHorzLayout(LAYOUT_AUTO);
	this->SetVertLayout(LAYOUT_AUTO);

	MQFrame *frame = CreateVerticalFrame(this);
	m_pointX = CreateEdit(frame, L"X");
	m_pointX->SetMaxLength(20);
	m_pointY = CreateEdit(frame, L"Y");
	m_pointY->SetMaxLength(20);
	m_pointZ = CreateEdit(frame, L"Z");
	m_pointZ->SetMaxLength(20);

	AddHideEvent(this, &ViewPointWindow::OnHide);
}

ViewPointWindow::~ViewPointWindow()
{
}

std::wstring ftostr(float f)
{
	char s[25];
	sprintf_s(s, "%-16.8f", f);
	return cmq::towstring(s);
}

BOOL ViewPointWindow::clear()
{
	m_pointX->SetText(L"");
	m_pointY->SetText(L"");
	m_pointZ->SetText(L"");
	return TRUE;
}

BOOL ViewPointWindow::viewPoint(const MQPoint &p)
{
	m_pointX->SetText(ftostr(p.x));
	m_pointY->SetText(ftostr(p.y));
	m_pointZ->SetText(ftostr(p.z));
	return TRUE;
}

BOOL ViewPointWindow::OnHide(MQWidgetBase *sender, MQDocument doc)
{
	if(m_pPlugin->m_bActivate){
		m_pPlugin->m_bActivate = false;
		m_pPlugin->WindowClose();
	}
	return FALSE;
}
